/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navikey.ui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.event.MouseEvent;
import java.util.Locale;
import javax.swing.DefaultListSelectionModel;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JLabel;

import java.util.Vector;

import net.metadiversity.diversity.navikey.bo.BasicState;

import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * MultiStatePanel.java
 *
 * @author Michael Bartley
 * 3/25/98
 * @author Dieter Neubacher
 */
/*
class JScrollPaneToTopAction implements ActionListener 
{
  javax.swing.JScrollPane scrollPane;
  public JScrollPaneToTopAction(javax.swing.JScrollPane scrollPane) 
  {
    if (scrollPane == null) {
      throw new IllegalArgumentException(
        "JScrollPaneToTopAction: null JScrollPane");
    }
    this.scrollPane = scrollPane;
  }
  public void actionPerformed(ActionEvent actionEvent) {
    javax.swing.JScrollBar verticalScrollBar = scrollPane.getVerticalScrollBar();
    javax.swing.JScrollBar horizontalScrollBar = scrollPane.getHorizontalScrollBar();
//    verticalScrollBar.setValue(verticalScrollBar.getMinimum());
//    horizontalScrollBar.setValue(horizontalScrollBar.getMinimum());
    verticalScrollBar.setValue(verticalScrollBar.getMaximum());
    horizontalScrollBar.setValue(horizontalScrollBar.getMaximum());
    
    System.out.println( "XXXXXXXXXXXXXXXXXXXXXXX" );
  }
};
*/

class MultiStatePanel extends javax.swing.JPanel // implements ActionListener 
{
  class MyAdjustmentListener implements AdjustmentListener {
    public void adjustmentValueChanged(AdjustmentEvent e) {
      System.out.println( "Value is " + e.getValue() + "      ");
      repaint();
    }
  }   
  
   /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257008769614690608L;
    
    private Vector<BasicState>      basicStates;
    private JList                   theList;
    private javax.swing.JScrollPane jScrollPane;
    private Vector<String>          listData;
    private JButton                 selectButton;
    // ??? private BasicState toBeReturned;
    private java.awt.event.ActionListener navikeyGuiListener;
    
    private final static int VISIBLE_ROWS = 15;    
    private boolean enableColorSelection = false;
/*   
    public void actionPerformed(ActionEvent actionEvent) 
    {
      jScrollPane.getVerticalScrollBar().setValue( 0 );
      jScrollPane.getHorizontalScrollBar().setValue( 0 );
    }
 */
    public MultiStatePanel( NaviKey navikey )
    {
        super();
        listData = new Vector<String>();
        setLayout( new BorderLayout() ); 
/*        
        jScrollPane.applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT);
        jScrollPane.getHorizontalScrollBar().applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT);
        this.applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT );
 */
        // "Character states available"
        JLabel title = new JLabel( navikey.getGuiString( "MultiStatePanel_title" ) );
        add( java.awt.BorderLayout.NORTH, title );
        
        basicStates = new Vector<BasicState>();
        
        theList = new JList( listData );        
        theList.setVisibleRowCount( VISIBLE_ROWS );
        theList.setSelectionMode( javax.swing.ListSelectionModel.SINGLE_SELECTION );
        
        jScrollPane = new javax.swing.JScrollPane();
//        jScrollPane.applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT );
        jScrollPane.setViewportView( theList );
        
        jScrollPane.validate();        
        add( java.awt.BorderLayout.CENTER, jScrollPane );
        // add select button (multiple selection)
        
        selectButton = new JButton( navikey.getGuiString( "MultiStatePanel_selectButton" ) );
        add( BorderLayout.SOUTH, selectButton );
        
        if( enableColorSelection )
        {
            theList.setBackground( NaviKey.naviKeyBackgroundColor );
            theList.setForeground( NaviKey.itemStateColor );
        }
//        this.applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT );                        
        this.validate();
        setVisible( true );

        theList.addListSelectionListener( new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged( javax.swing.event.ListSelectionEvent evt )
            {
                ValueChanged( evt );
            }
        } );
                
        selectButton.addActionListener( new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
//                System.out.println( evt.toString() );
                updateGui();
            }
        });
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    void updateGui()
    {
        java.awt.event.ActionEvent ae = new java.awt.event.ActionEvent( this, 1, "UpdateGui" );
        
        navikeyGuiListener.actionPerformed( ae );        
    }    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    private void ValueChanged( javax.swing.event.ListSelectionEvent evt )
    {
        // System.out.println( "MultiStatePanel : " + evt );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /*
    private void MouseClicked( java.awt.event.MouseEvent evt )
    {
        System.out.println( evt );
    } 
     */   
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addListSelectionListener( javax.swing.event.ListSelectionListener l )
    {
    	// enable multible selection
    	theList.setSelectionMode( DefaultListSelectionModel.MULTIPLE_INTERVAL_SELECTION );
        theList.addListSelectionListener( l );
    }
    //--------------------------------------------------------------------------
    // ??? if multible states can be selected. So we have to return a vactor of BasicStates
    //--------------------------------------------------------------------------
    public BasicState getState( int index )
    {
        return basicStates.elementAt( index );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public void setStates( Vector<BasicState> basicStates )
    {
        this.basicStates = basicStates;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------  
    public void updateList()
    {         
        java.util.Comparator<BasicState> myComparator = new java.util.Comparator<BasicState>()
        {
            public int compare( BasicState a, BasicState b)
            {
                return a.getName().compareTo( b.getName() );         
            }
        };

        java.util.Collections.sort( basicStates, myComparator );
        listData.removeAllElements();
        for( int i = 0; i < basicStates.size(); i++ )
        {
            BasicState temp = basicStates.elementAt( i );
            listData.add( temp.getName() );
        }
        
        
//    java.util.Vector<String> listData = new java.util.Vector<String>();
/*        
    listData = new java.util.Vector<String>();    
    for( int i = 0; i < 100; i++ )
    {    
        java.lang.String s = " Label " + i + " Label " + i + " Label " + i 
                           + " Label " + i + " Label " + i + " Label " + i 
                           + " Label " + i + " Label " + i + " Label " + i 
                           + " Label " + i + " Label " + i + " Label " + i ;
        listData.add( s );
    }
  */      
        
        // java.util.Collections.sort( listData );
//        System.out.println( listData );
        theList.setListData( listData );
        theList.validate();

//        theList.setVisibleRowCount( VISIBLE_ROWS );
//    	theList.setSelectionMode( DefaultListSelectionModel.MULTIPLE_INTERVAL_SELECTION );
//        jScrollPane = new javax.swing.JScrollPane();
//        jScrollPane.applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT );
//        jScrollPane.setViewportView( theList );
        jScrollPane.validate();
        jScrollPane.getVerticalScrollBar().setValue( jScrollPane.getVerticalScrollBar().getMinimum() );
        jScrollPane.getHorizontalScrollBar().setValue( jScrollPane.getHorizontalScrollBar().getMinimum() );
        jScrollPane.setVisible( true );
//        add( java.awt.BorderLayout.CENTER, jScrollPane );
        
//        System.out.println( "Update character state list.");
//        System.out.println( listData );
//        theList.setBackground( Color.red );
//        this.setComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT );        
//        this.setComponentOrientation( ComponentOrientation.LEFT_TO_RIGHT );        
//        jScrollPane.setLocale( new Locale( "ar" ) );
//        jScrollPane.setLocation( 0, 0 );
//        jScrollPane.setBackground( Color.red );
//        jScrollPane.getParent().setBackground( Color.red );
//        jScrollPane.getParent().applyComponentOrientation( ComponentOrientation.LEFT_TO_RIGHT );        
//        jScrollPane.getParent().applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT );        
        // jScrollPane.getHorizontalScrollBar().applyComponentOrientation( ComponentOrientation.LEFT_TO_RIGHT ); 
//        jScrollPane.getHorizontalScrollBar().setBackground( Color.red );
//        jScrollPane.getHorizontalScrollBar().setValue( 20 );
//        this.firePropertyChange( TOOL_TIP_TEXT_KEY, ui, ui );
//        jScrollPane.getHorizontalScrollBar().;
        // JScrollPaneToTopAction a = new JScrollPaneToTopAction( jScrollPane );                
        // a.actionPerformed( null );
//        System.out.println( "Value:" + jScrollPane.getHorizontalScrollBar().getValue() );
//        System.out.println( "Min  :" + jScrollPane.getHorizontalScrollBar().getMinimum() );
//        System.out.println( "Max  :" + jScrollPane.getHorizontalScrollBar().getMaximum() );
//        System.out.println( "Max  :" + jScrollPane );
//        jScrollPane.getHorizontalScrollBar().repaint();
//        jScrollPane.getHorizontalScrollBar().addAdjustmentListener( new MyAdjustmentListener() );
        /*
        theList.applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT );
        jScrollPane.applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT );
        jScrollPane.getHorizontalScrollBar().applyComponentOrientation( ComponentOrientation.RIGHT_TO_LEFT );
*/
//        jScrollPane.getHorizontalScrollBar().setValue(jScrollPane.getHorizontalScrollBar().getMaximum() );
//        jScrollPane.getHorizontalScrollBar().setValue( 0 );
        
//        jScrollPane.validate();        
//        theList.validate();
                
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
/*    
    public JList getTheList()
    {
        return theList;
    }
     
     */
    //--------------------------------------------------------------------------    
    //--------------------------------------------------------------------------        
    public void addNavikeyGuiListener( java.awt.event.ActionListener al )
    {
        navikeyGuiListener = al;
    }    
}
