/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.metadiversity.diversity.navikey.util;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author didi
 */
public class CharsToLiasLightInsertSql
{
    final static String charStart = "#";
    final static String skipLines = "*";
    final static String csTable   = "LIASlight_CS_Translation";
    final static String charTable = "LIASlight_CHAR_Translation";

    final static String csSQL   = "INSERT INTO \"" + csTable + "\" " +
                                   "( \"StateID\", \"Language\", \"CharStateName\" ) " +
                                   " VALUES ( (SELECT \"StateID\" FROM \"LIASlight_CS\" WHERE \"CID\" = '#CID#' AND \"CS\" = '#CS#'), " +
                                   "'#LANGUAGE#', '#CHAR_STATE_NAME#' );";

    final static String charSQL = "INSERT INTO \"" + charTable + "\" " +
                                   "( \"CharID\", \"Language\", \"CharName\" ) " +
                                   "VALUES ( #CID#,  '#LANGUAGE#', '#CHAR_NAME#' );";




    public CharsToLiasLightInsertSql( String charsFile, String sqlFile, String language )
    {
/*
        java.io.BufferedReader in  = new java.io.BufferedReader( new java.io.InputStreamReader( System.in ) );
        java.io.BufferedWriter out = new java.io.BufferedWriter( new java.io.OutputStreamWriter( System.out ) );
         */
        java.io.BufferedReader in = null;
        java.io.BufferedWriter out = null;
        String str = null;
        try 
        {            
            in = new java.io.BufferedReader(new java.io.FileReader(charsFile));
            out = new java.io.BufferedWriter(new java.io.FileWriter(sqlFile));
            String sql = "";
            int readlines = 0;
            String lastCharacterID = "";
            while ( true )
            {
                readlines++;
                str = in.readLine();
                if ( str == null )
                {
                    break;
                }
                if ( str.length() < 1 )
                {
                    continue;
                }
                System.out.println( str );
                str = str.trim();
                String data = "";
                if ( str.startsWith( skipLines ) )
                {
                    continue;
                }
                if ( str.startsWith( charStart ) )
                {
                    // get Character ID
                    int endPos = str.indexOf('.');
                    if ( endPos > 0 )
                    {
                        int id = Integer.parseInt( str.substring( 1, endPos) );
                        lastCharacterID = String.valueOf(id);
                        data = str.substring( endPos + 2, str.length() -1  );
                        data = data.replace( "'", "\\'" );
                    }
                    else
                    {
                        System.exit( 2 );
                    }
                    // SQL
                    sql = charSQL;
                    sql = sql.replace( "#CID#", lastCharacterID );
                    sql = sql.replace( "#LANGUAGE#", language   );
                    sql = sql.replace( "#CHAR_NAME#", data      );
    

                    out.write( sql );
                    out.newLine();
                }
                else
                {
                    String state = "";
                    // get Character state ID
                    int endPos = str.indexOf('.');
                    if ( endPos > 0 )
                    {
                        int id = Integer.parseInt( str.substring( 0, endPos ) );
                        state = String.valueOf(id);
                        data = str.substring( endPos + 2, str.length() -1 );
                        data = data.replace( "'", "''" );
//                        data = data.replace( "\"", "\\\"" );
                    }
                    else
                    {
                        System.exit( 3 );  // de_DE ERROR ???
                    }
                    // Skip (genus) Character 7
                    if( lastCharacterID.equals( "7" )  )
                    {
                        continue;
                    }
                    // Skip (familie) Character 8 and CharacterState > 2
                    if( lastCharacterID.equals( "8" ) )
                    {
                        if( ! ( state.equals( "1") || state.equals( "2") ) )
                        {
                            continue;
                        }
                    }
                    // Skip (familie) Character 8 and CharacterState > 2
                    if( lastCharacterID.equals( "9" ) )
                    {
                        if( ! ( state.equals( "23") ) )
                        {
                            continue;
                        }
                    }

                    sql = csSQL;
                    sql = sql.replace( "#CID#", lastCharacterID);
                    sql = sql.replace( "#CS#", state);
                    sql = sql.replace( "#LANGUAGE#", language);
                    sql = sql.replace( "#CHAR_STATE_NAME#", data);
                    out.write( sql );
                    out.newLine();
                }
            }
            out.flush();
            out.close();
        }
        catch ( java.lang.NullPointerException ex )
        {
            Logger.getLogger(CharsToLiasLightInsertSql.class.getName()).log(Level.SEVERE, null, ex);
        }
        catch ( java.io.FileNotFoundException ex )
        {
            Logger.getLogger(CharsToLiasLightInsertSql.class.getName()).log(Level.SEVERE, null, ex);
        }
        catch (java.io.IOException ex)
        {
            ex.printStackTrace();
        }
    }
    public static void main( String args[] )
    {
        if( args.length == 0 || args.length > 1 )
        {
            System.err.println( "Usage: CharsToLiasLightInsertSql <chars-file> <output-sql-file> <language>");
//            System.exit( 0 );
        }
        // System.out.println( args[ 0 ] );
//        new CharsToLiasLightInsertSql( args[ 0 ], args[ 1 ], args[ 2 ] );
//        new CharsToLiasLightInsertSql( "/home/didi/chars.es_ES", "/home/didi/chars.es_ES.sql", "es_ES" );
//        new CharsToLiasLightInsertSql( "/home/didi/chars.ru_RU", "/home/didi/chars.ru_RU.sql", "ru_RU" );
//        new CharsToLiasLightInsertSql( "/home/didi/chars.de_DE", "/home/didi/chars.de_DE.sql", "de_DE" );
        new CharsToLiasLightInsertSql( "/home/didi/chars.it_IT", "/home/didi/chars.it_IT.sql", "it_IT" );
    }
}
